#include<stdio.h>
#include<stdlib.h>

int conway(int N, int M, int (*current_grid)[M], int (*next_grid)[M]) {
  int total = 0;
  for (int i = 1; i < N - 1; i++) {
    for (int j = 1; j < M - 1; j++) {
      int count = 0;
      for (int ii = -1; ii <= 1; ii++)
        for (int jj = -1; jj <= 1; jj++)
          if (ii != 0 || jj != 0)
            count += current_grid[i+ii][j+jj];
      if (count == 3)
        next_grid[i][j] = 1;
      else if (count == 2)
        next_grid[i][j] = current_grid[i][j];
      else
        next_grid[i][j] = 0;
      total += next_grid[i][j];
    }
  }
  return total;
}

void print_grid(int N, int M, int* grid) {
  for (int i = 0; i < N; i++) {
    for (int j = 0; j < M; j++) {
      if (grid[M*i+j]) printf("#");
      else printf(" ");
    }
    printf("\n");
  }
}

int main(int argc, char** argv) {
  if (argc != 5) {
    printf("Usage: %s <grid_size_x> <grid_size_y> <timesteps> <fill-factor>\n", argv[0]);
    return;
  }
  int N = atoi(argv[1]);
  int M = atoi(argv[2]);
  int T = atoi(argv[3]);
  double fill = atof(argv[4]);
  int *grid_0 = calloc(N, M * sizeof(int));
  int *grid_1 = calloc(N, M * sizeof(int));
  for (int i = 1; i < N-1; i++)
    for (int j = 1; j < M-1; j++)
      grid_0[M*i+j] = rand() < (RAND_MAX * fill);
  //print_grid(N, M, grid_0);
  for (int t = 0; t < T; t++) {
    int count = conway(N, M, (void*) grid_0, (void*) grid_1);
    print_grid(N, M, grid_1);
    printf("%d %d\n", t, count);
    int *tmp = grid_0;
    grid_0 = grid_1;
    grid_1 = tmp;
  }
  free(grid_0);
  free(grid_1);
}
